=== python_examples/requirements.txt ===
scikit-image>=0.9.3
opencv-python 
numpy
