=== debian/changelog ===
dlib (19.10-3.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Backport upstream fix for using cv_image.h with OpenCV 4,
    thanks to Alexandr Podgorniy. (Closes: #990676)

 -- Adrian Bunk <bunk@debian.org>  Thu, 15 Jul 2021 17:19:19 +0300

dlib (19.10-3) unstable; urgency=medium

  * Team upload.
  * Moved packaging to Debian Science team (acknowledged by Uploaders)
  * Enable building with dpkg-buildpackage -A (thanks for the patch to
    Santiago Vila <sanvila@debian.org>)
    Closes: #918567
  * Standards-Version: 4.3.0
  * cme fix dpkg-control

 -- Andreas Tille <tille@debian.org>  Thu, 17 Jan 2019 08:17:25 +0100

dlib (19.10-2) unstable; urgency=medium

  * Add missing debian/copyright entries (Closes: #895701).
  * Bump Standards-Version to 4.1.4.

 -- Hugo Lefeuvre <hle@debian.org>  Sat, 14 Apr 2018 23:15:38 -0400

dlib (19.10-1) unstable; urgency=medium

  * New upstream release (Closes: #894118).
    - Update debian/docs to match new upstream paths.
    - Rewrite and cleanup debian/rules to match new upstream build system
      decisions.
    - Update binary package name accordingly.
  * New co-maintainer (Hugo Lefeuvre).
    - Add Uploaders entry for Hugo Lefeuvre.
    - Add debian/copyright entry for Hugo Lefeuvre.
  * Add Multi-Arch support (Closes: #894617):
    - Add required Multi-Arch fields in debian/control.
    - Update debian/*.install files to match new paths.
    - Add missing Pre-Depends field.
  * Fix soft links: Generate links files at build time, add required
    debian/*.links.in files.
  * Remove useless debian/*.dirs files.
  * Build with hardening flags.
  * Migrate repository to Salsa: update Vcs-* fields in debian/control.
  * Bump compat to 11 and update debhelper dependency accordingly.
  * Bump Standards-Version to 4.1.3.
  * Bump copyright years.
  * Update links to use HTTPS protocol.
  * Run wrap-and-sort -a.

 -- Hugo Lefeuvre <hle@debian.org>  Fri, 30 Mar 2018 21:23:27 -0400
